/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.sendaAmigo;

import com.rjconsultores.ventaboletos.entidad.TipoMovimiento;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.HibernateSearchObject;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.PagedListWrapper;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderTipoMovimiento;
import java.util.HashMap;
import java.util.Map;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Messagebox;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zk.ui.event.EventListener;
import org.zkoss.zul.Paging;
import org.zkoss.zul.Textbox;

/**
 *
 * @author Administrador
 */
@Controller("busquedaTipoMovimientoController")
@Scope("prototype")
public class BusquedaTipoMovimientoController extends MyGenericForwardComposer {

    @Autowired
    private transient PagedListWrapper<TipoMovimiento> plwTipoMovimiento;
    private MyListbox tipoMovimientoList;
    private Paging pagingTipoMovimiento;
    private Textbox txtNome;

    public Paging getPagingTipoMovimiento() {
        return pagingTipoMovimiento;
    }

    public void setPagingTipoMovimiento(Paging pagingTipoMovimiento) {
        this.pagingTipoMovimiento = pagingTipoMovimiento;
    }

    public MyListbox getTipoMovimientoList() {
        return tipoMovimientoList;
    }

    public void setTipoMovimientoList(MyListbox tipoMovimientoList) {
        this.tipoMovimientoList = tipoMovimientoList;
    }

    public Textbox getTxtNome() {
        return txtNome;
    }

    public void setTxtNome(Textbox txtNome) {
        this.txtNome = txtNome;
    }

    @Override
    public void doAfterCompose(Component comp) throws Exception {
        super.doAfterCompose(comp);

        tipoMovimientoList.setItemRenderer(new RenderTipoMovimiento());
        tipoMovimientoList.addEventListener("onDoubleClick", new EventListener() {

            @Override
            public void onEvent(Event event) throws Exception {
                TipoMovimiento a = (TipoMovimiento) tipoMovimientoList.getSelected();
                verTipoMovimiento(a);
            }
        });

        refreshLista();

        txtNome.focus();
    }

    private void verTipoMovimiento(TipoMovimiento a) {
        if (a == null) {
            return;
        }

        Map args = new HashMap();
        args.put("busquedaTipoMovimientoController", this);
        args.put("tipoMovimiento", a);
        args.put("tipoMovimientoList", tipoMovimientoList);

        openWindow("/gui/senda_amigo/editarTipoMovimiento.zul",
                Labels.getLabel("editarTipoMovimientoController.window.title"), args, MODAL);
    }

    public void refreshLista() {
        HibernateSearchObject<TipoMovimiento> tipoMovimientoBusqueda =
                new HibernateSearchObject<TipoMovimiento>(TipoMovimiento.class,
                pagingTipoMovimiento.getPageSize());

        tipoMovimientoBusqueda.addFilterLike("descmovimiento",
                "%" + txtNome.getText().trim().concat("%"));

        tipoMovimientoBusqueda.addSortAsc("descmovimiento");
        tipoMovimientoBusqueda.addFilterEqual("activo", Boolean.TRUE);

        plwTipoMovimiento.init(tipoMovimientoBusqueda, tipoMovimientoList, pagingTipoMovimiento);

        if (tipoMovimientoList.getData().length == 0) {
            try {
                Messagebox.show(Labels.getLabel("MSG.ningunRegistro"),
                        Labels.getLabel("busquedaTipoMovimientoController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);
            } catch (InterruptedException ex) {
            }
        }
    }

    public void onClick$btnPesquisa(Event ev) {
        refreshLista();
    }

    public void onClick$btnRefresh(Event ev) {
        refreshLista();
    }

    public void onClick$btnNovo(Event ev) {
        verTipoMovimiento(new TipoMovimiento());
    }
}
